'use strict';

var myreactShared = {exports: {}};

var index_development = {};

var hasRequiredIndex_development;

function requireIndex_development () {
	if (hasRequiredIndex_development) return index_development;
	hasRequiredIndex_development = 1;
	(function (exports) {

		var merge = function (src, rest) {
		    return src | rest;
		};
		var remove = function (src, rest) {
		    if (src & rest) {
		        return src ^ rest;
		    }
		    else {
		        return src;
		    }
		};
		var include = function (src, rest) {
		    return !!(src & rest);
		};
		var exclude = function (src, rest) {
		    return !(src & rest);
		};

		/******************************************************************************
		Copyright (c) Microsoft Corporation.

		Permission to use, copy, modify, and/or distribute this software for any
		purpose with or without fee is hereby granted.

		THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
		REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
		AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
		INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
		LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
		OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
		PERFORMANCE OF THIS SOFTWARE.
		***************************************************************************** */
		/* global Reflect, Promise, SuppressedError, Symbol, Iterator */


		function __spreadArray(to, from, pack) {
		    if (arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
		        if (ar || !(i in from)) {
		            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
		            ar[i] = from[i];
		        }
		    }
		    return to.concat(ar || Array.prototype.slice.call(from));
		}

		typeof SuppressedError === "function" ? SuppressedError : function (error, suppressed, message) {
		    var e = new Error(message);
		    return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
		};

		var once = function (action) {
		    var called = false;
		    return function () {
		        var args = [];
		        for (var _i = 0; _i < arguments.length; _i++) {
		            args[_i] = arguments[_i];
		        }
		        if (called)
		            return;
		        called = true;
		        if (typeof action === "function")
		            action.call.apply(action, __spreadArray([null], args, false));
		    };
		};

		var TYPEKEY = "$$typeof";
		var Element = Symbol.for("react.element");
		var Memo = Symbol.for("react.memo");
		var ForwardRef = Symbol.for("react.forward_ref");
		var Portal = Symbol.for("react.portal");
		var Fragment = Symbol.for("react.fragment");
		var Context = Symbol.for("react.context");
		var Provider = Symbol.for("react.provider");
		var Consumer = Symbol.for("react.consumer");
		var Lazy = Symbol.for("react.lazy");
		var Suspense = Symbol.for("react.suspense");
		var Strict = Symbol.for("react.strict_mode");
		var Root = Symbol.for("react.root");
		var Scope = Symbol.for("react.scope");
		var ScopeLazy = Symbol.for("react.scope_lazy");
		var ScopeSuspense = Symbol.for("react.scope_suspense");
		var Comment = Symbol.for("react.comment");
		var Offscreen = Symbol.for("react.offscreen");
		var Profiler = Symbol.for("react.profiler");

		function isObject(target) {
		    return typeof target === "object" && target !== null;
		}
		function isFunction(target) {
		    return typeof target === "function";
		}
		function isArray(target) {
		    return Array.isArray(target);
		}
		function isSymbol(target) {
		    return typeof target === "symbol";
		}
		function isString(target) {
		    return typeof target === "string";
		}
		function isInteger(target) {
		    return Number.isInteger(Number(target));
		}
		function isNumber(target) {
		    return typeof target === "number";
		}
		function isCollection(target) {
		    return target instanceof Map || target instanceof Set || target instanceof WeakMap || target instanceof WeakSet;
		}
		var isPromise = function (val) {
		    return (isObject(val) || isFunction(val)) && isFunction(val.then) && isFunction(val.catch);
		};

		var UniqueArray = /** @class */ (function () {
		    function UniqueArray() {
		        this.set = new Set();
		        this.arr = new Array();
		        this.length = 0;
		    }
		    UniqueArray.prototype.uniPop = function () {
		        var v = this.arr.pop();
		        this.set.delete(v);
		        this.length--;
		        return v;
		    };
		    UniqueArray.prototype.uniPush = function (v) {
		        if (this.set.has(v))
		            return 0;
		        this.set.add(v);
		        this.arr.push(v);
		        this.length++;
		    };
		    UniqueArray.prototype.uniShift = function () {
		        var v = this.arr.shift();
		        this.set.delete(v);
		        this.length--;
		        return v;
		    };
		    UniqueArray.prototype.uniUnshift = function (v) {
		        if (this.set.has(v))
		            return 0;
		        this.set.add(v);
		        this.arr.unshift(v);
		        this.length++;
		    };
		    UniqueArray.prototype.uniDelete = function (v) {
		        if (this.set.has(v)) {
		            this.set.delete(v);
		            this.arr = this.arr.filter(function (i) { return i !== v; });
		            this.length--;
		        }
		    };
		    UniqueArray.prototype.clear = function () {
		        this.length = 0;
		        this.set.clear();
		        this.arr.length = 0;
		    };
		    UniqueArray.prototype.getAll = function () {
		        return this.arr;
		    };
		    return UniqueArray;
		}());

		exports.HOOK_TYPE = void 0;
		(function (HOOK_TYPE) {
		    HOOK_TYPE[HOOK_TYPE["useId"] = 0] = "useId";
		    HOOK_TYPE[HOOK_TYPE["useRef"] = 1] = "useRef";
		    HOOK_TYPE[HOOK_TYPE["useMemo"] = 2] = "useMemo";
		    HOOK_TYPE[HOOK_TYPE["useState"] = 3] = "useState";
		    HOOK_TYPE[HOOK_TYPE["useSignal"] = 4] = "useSignal";
		    HOOK_TYPE[HOOK_TYPE["useEffect"] = 5] = "useEffect";
		    HOOK_TYPE[HOOK_TYPE["useContext"] = 6] = "useContext";
		    HOOK_TYPE[HOOK_TYPE["useReducer"] = 7] = "useReducer";
		    HOOK_TYPE[HOOK_TYPE["useCallback"] = 8] = "useCallback";
		    HOOK_TYPE[HOOK_TYPE["useTransition"] = 9] = "useTransition";
		    HOOK_TYPE[HOOK_TYPE["useDebugValue"] = 10] = "useDebugValue";
		    HOOK_TYPE[HOOK_TYPE["useLayoutEffect"] = 11] = "useLayoutEffect";
		    HOOK_TYPE[HOOK_TYPE["useDeferredValue"] = 12] = "useDeferredValue";
		    HOOK_TYPE[HOOK_TYPE["useInsertionEffect"] = 13] = "useInsertionEffect";
		    HOOK_TYPE[HOOK_TYPE["useImperativeHandle"] = 14] = "useImperativeHandle";
		    HOOK_TYPE[HOOK_TYPE["useSyncExternalStore"] = 15] = "useSyncExternalStore";
		})(exports.HOOK_TYPE || (exports.HOOK_TYPE = {}));

		exports.UpdateQueueType = void 0;
		(function (UpdateQueueType) {
		    UpdateQueueType[UpdateQueueType["component"] = 1] = "component";
		    UpdateQueueType[UpdateQueueType["hook"] = 2] = "hook";
		    UpdateQueueType[UpdateQueueType["context"] = 3] = "context";
		    UpdateQueueType[UpdateQueueType["hmr"] = 4] = "hmr";
		    UpdateQueueType[UpdateQueueType["trigger"] = 5] = "trigger";
		    UpdateQueueType[UpdateQueueType["suspense"] = 6] = "suspense";
		})(exports.UpdateQueueType || (exports.UpdateQueueType = {}));

		exports.STATE_TYPE = void 0;
		(function (STATE_TYPE) {
		    STATE_TYPE[STATE_TYPE["__initial__"] = 0] = "__initial__";
		    STATE_TYPE[STATE_TYPE["__create__"] = 1] = "__create__";
		    STATE_TYPE[STATE_TYPE["__stable__"] = 2] = "__stable__";
		    STATE_TYPE[STATE_TYPE["__skippedConcurrent__"] = 4] = "__skippedConcurrent__";
		    STATE_TYPE[STATE_TYPE["__skippedSync__"] = 8] = "__skippedSync__";
		    STATE_TYPE[STATE_TYPE["__inherit__"] = 16] = "__inherit__";
		    STATE_TYPE[STATE_TYPE["__triggerConcurrent__"] = 32] = "__triggerConcurrent__";
		    STATE_TYPE[STATE_TYPE["__triggerConcurrentForce__"] = 64] = "__triggerConcurrentForce__";
		    STATE_TYPE[STATE_TYPE["__triggerSync__"] = 128] = "__triggerSync__";
		    STATE_TYPE[STATE_TYPE["__triggerSyncForce__"] = 256] = "__triggerSyncForce__";
		    STATE_TYPE[STATE_TYPE["__unmount__"] = 512] = "__unmount__";
		    STATE_TYPE[STATE_TYPE["__hmr__"] = 1024] = "__hmr__";
		    STATE_TYPE[STATE_TYPE["__retrigger__"] = 2048] = "__retrigger__";
		    STATE_TYPE[STATE_TYPE["__reschedule__"] = 4096] = "__reschedule__";
		})(exports.STATE_TYPE || (exports.STATE_TYPE = {}));

		exports.PATCH_TYPE = void 0;
		(function (PATCH_TYPE) {
		    PATCH_TYPE[PATCH_TYPE["__initial__"] = 0] = "__initial__";
		    PATCH_TYPE[PATCH_TYPE["__create__"] = 1] = "__create__";
		    PATCH_TYPE[PATCH_TYPE["__update__"] = 2] = "__update__";
		    PATCH_TYPE[PATCH_TYPE["__append__"] = 4] = "__append__";
		    PATCH_TYPE[PATCH_TYPE["__position__"] = 8] = "__position__";
		    PATCH_TYPE[PATCH_TYPE["__effect__"] = 16] = "__effect__";
		    PATCH_TYPE[PATCH_TYPE["__layoutEffect__"] = 32] = "__layoutEffect__";
		    PATCH_TYPE[PATCH_TYPE["__insertionEffect__"] = 64] = "__insertionEffect__";
		    PATCH_TYPE[PATCH_TYPE["__unmount__"] = 128] = "__unmount__";
		    PATCH_TYPE[PATCH_TYPE["__ref__"] = 256] = "__ref__";
		})(exports.PATCH_TYPE || (exports.PATCH_TYPE = {}));

		exports.Effect_TYPE = void 0;
		(function (Effect_TYPE) {
		    Effect_TYPE[Effect_TYPE["__initial__"] = 0] = "__initial__";
		    Effect_TYPE[Effect_TYPE["__effect__"] = 1] = "__effect__";
		    Effect_TYPE[Effect_TYPE["__unmount__"] = 2] = "__unmount__";
		})(exports.Effect_TYPE || (exports.Effect_TYPE = {}));

		var compareVersion = function (version1, version2) {
		    var compare = function (arr1, arr2) {
		        if (arr1.length && arr2.length) {
		            var v1 = arr1[0];
		            var v2 = arr2[0];
		            if (v1 > v2)
		                return true;
		            if (v2 > v1)
		                return false;
		            return compare(arr1.slice(1), arr2.slice(1));
		        }
		        if (arr1.length)
		            return true;
		        if (arr2.length)
		            return false;
		        return true;
		    };
		    return compare(version1.split(".").map(Number), version2.split(".").map(Number));
		};

		var isNormalEquals = function (src, target, isSkipKey) {
		    var isEquals = Object.is(src, target);
		    if (isEquals)
		        return true;
		    var hasSkipKeyFunction = typeof isSkipKey === "function";
		    if (typeof src === "object" && typeof target === "object" && src !== null && target !== null) {
		        var srcKeys = Object.keys(src);
		        var targetKeys = Object.keys(target);
		        if (srcKeys.length !== targetKeys.length)
		            return false;
		        var res = true;
		        if (hasSkipKeyFunction) {
		            for (var _i = 0, srcKeys_1 = srcKeys; _i < srcKeys_1.length; _i++) {
		                var key = srcKeys_1[_i];
		                if (isSkipKey(key) && key in target) {
		                    continue;
		                }
		                else {
		                    res = res && Object.is(src[key], target[key]);
		                }
		                if (!res)
		                    return res;
		            }
		        }
		        else {
		            for (var _a = 0, srcKeys_2 = srcKeys; _a < srcKeys_2.length; _a++) {
		                var key = srcKeys_2[_a];
		                res = res && Object.is(src[key], target[key]);
		                if (!res)
		                    return res;
		            }
		        }
		        return res;
		    }
		    return false;
		};
		var isArrayEquals = function (src, target) {
		    var isEquals = Object.is(src, target);
		    if (isEquals)
		        return true;
		    if (Array.isArray(src) && Array.isArray(target) && src.length === target.length) {
		        var re = true;
		        for (var key in src) {
		            re = re && Object.is(src[key], target[key]);
		            if (!re)
		                return re;
		        }
		        return re;
		    }
		    return false;
		};

		var ListTreeNode = /** @class */ (function () {
		    function ListTreeNode(value) {
		        this.prev = null;
		        this.next = null;
		        this.value = value;
		    }
		    return ListTreeNode;
		}());
		var ListTree = /** @class */ (function () {
		    function ListTree() {
		        this.length = 0;
		        var _stickyHead = null;
		        Object.defineProperty(this, "stickyHead", {
		            get: function () {
		                return _stickyHead;
		            },
		            set: function (v) {
		                _stickyHead = v;
		            },
		        });
		        var _stickyFoot = null;
		        Object.defineProperty(this, "stickyFoot", {
		            get: function () {
		                return _stickyFoot;
		            },
		            set: function (v) {
		                _stickyFoot = v;
		            },
		        });
		        var _head = null;
		        Object.defineProperty(this, "head", {
		            get: function () {
		                return _head;
		            },
		            set: function (v) {
		                _head = v;
		            },
		        });
		        var _foot = null;
		        Object.defineProperty(this, "foot", {
		            get: function () {
		                return _foot;
		            },
		            set: function (v) {
		                _foot = v;
		            },
		        });
		    }
		    ListTree.prototype.push = function (node) {
		        var listNode = new ListTreeNode(node);
		        this.length++;
		        if (!this.foot) {
		            this.head = listNode;
		            this.foot = listNode;
		        }
		        else {
		            this.foot.next = listNode;
		            listNode.prev = this.foot;
		            this.foot = listNode;
		        }
		    };
		    ListTree.prototype.pushToLast = function (node) {
		        if (this.stickyFoot) {
		            var node_1 = this.stickyFoot;
		            this.push(node_1.value);
		            this.stickyFoot = null;
		        }
		        else {
		            this.length++;
		        }
		        var listNode = new ListTreeNode(node);
		        this.stickyFoot = listNode;
		    };
		    ListTree.prototype.pushToHead = function (node) {
		        if (this.stickyHead) {
		            var node_2 = this.stickyHead;
		            this.unshift(node_2.value);
		            this.stickyHead = null;
		        }
		        else {
		            this.length++;
		        }
		        var listNode = new ListTreeNode(node);
		        this.stickyHead = listNode;
		    };
		    ListTree.prototype.pop = function () {
		        var foot = this.stickyFoot || this.foot || this.stickyHead;
		        if (foot) {
		            this.delete(foot);
		            return foot.value;
		        }
		        else {
		            return null;
		        }
		    };
		    ListTree.prototype.unshift = function (node) {
		        var listNode = new ListTreeNode(node);
		        this.length++;
		        if (!this.head) {
		            this.head = listNode;
		            this.foot = listNode;
		        }
		        else {
		            this.head.prev = listNode;
		            listNode.next = this.head;
		            this.head = listNode;
		        }
		    };
		    ListTree.prototype.unshiftToHead = function (node) {
		        if (this.stickyHead) {
		            var node_3 = this.stickyHead;
		            this.unshift(node_3.value);
		            this.stickyHead = null;
		        }
		        else {
		            this.length++;
		        }
		        var listNode = new ListTreeNode(node);
		        this.stickyHead = listNode;
		    };
		    ListTree.prototype.unshiftToFoot = function (node) {
		        if (this.stickyFoot) {
		            var node_4 = this.stickyFoot;
		            this.push(node_4.value);
		            this.stickyFoot = null;
		        }
		        else {
		            this.length++;
		        }
		        var listNode = new ListTreeNode(node);
		        this.stickyFoot = listNode;
		    };
		    ListTree.prototype.shift = function () {
		        var head = this.stickyHead || this.head || this.stickyFoot;
		        if (head) {
		            this.delete(head);
		            return head.value;
		        }
		        else {
		            return null;
		        }
		    };
		    ListTree.prototype.pickHead = function () {
		        var _a, _b;
		        return ((_a = this.stickyHead) === null || _a === void 0 ? void 0 : _a.value) || ((_b = this.head) === null || _b === void 0 ? void 0 : _b.value);
		    };
		    ListTree.prototype.pickFoot = function () {
		        var _a, _b;
		        return ((_a = this.stickyFoot) === null || _a === void 0 ? void 0 : _a.value) || ((_b = this.foot) === null || _b === void 0 ? void 0 : _b.value);
		    };
		    ListTree.prototype.listToFoot = function (action) {
		        if (this.stickyHead) {
		            action(this.stickyHead.value);
		        }
		        var node = this.head;
		        while (node) {
		            action(node.value);
		            node = node.next;
		        }
		        if (this.stickyFoot) {
		            action(this.stickyFoot.value);
		        }
		    };
		    ListTree.prototype.listToHead = function (action) {
		        if (this.stickyFoot) {
		            action(this.stickyFoot.value);
		        }
		        var node = this.foot;
		        while (node) {
		            action(node.value);
		            node = node.prev;
		        }
		        if (this.stickyHead) {
		            action(this.stickyHead.value);
		        }
		    };
		    ListTree.prototype.toArray = function () {
		        var re = [];
		        this.listToFoot(function (v) { return re.push(v); });
		        return re;
		    };
		    ListTree.prototype.delete = function (node) {
		        if (this.stickyHead === node) {
		            this.stickyHead = null;
		            this.length--;
		        }
		        else if (this.stickyFoot === node) {
		            this.stickyFoot = null;
		            this.length--;
		        }
		        else if (this.head === node) {
		            var next = node.next;
		            node.next = null;
		            if (next) {
		                this.head = next;
		                next.prev = null;
		            }
		            else {
		                this.head = null;
		                this.foot = null;
		            }
		            this.length--;
		        }
		        else if (this.foot === node) {
		            var prev = node.prev;
		            node.prev = null;
		            if (prev) {
		                this.foot = prev;
		                prev.next = null;
		            }
		            else {
		                this.head = null;
		                this.foot = null;
		            }
		            this.length--;
		        }
		        else if (this.hasNode(node)) {
		            var prev = node.prev;
		            var next = node.next;
		            node.prev = null;
		            node.next = null;
		            prev.next = next;
		            next.prev = prev;
		            this.length--;
		        }
		    };
		    ListTree.prototype.size = function () {
		        return this.length;
		    };
		    ListTree.prototype.hasNode = function (node) {
		        if (this.stickyHead && Object.is(this.stickyHead, node))
		            return true;
		        if (this.stickyFoot && Object.is(this.stickyFoot, node))
		            return true;
		        var listNode = this.head;
		        while (listNode) {
		            if (Object.is(listNode, node))
		                return true;
		            listNode = listNode.next;
		        }
		        return false;
		    };
		    ListTree.prototype.hasValue = function (node) {
		        if (this.stickyHead && Object.is(this.stickyHead.value, node))
		            return true;
		        if (this.stickyFoot && Object.is(this.stickyFoot.value, node))
		            return true;
		        var listNode = this.head;
		        while (listNode) {
		            if (Object.is(listNode.value, node))
		                return true;
		            listNode = listNode.next;
		        }
		        return false;
		    };
		    ListTree.prototype.some = function (iterator) {
		        var re = false;
		        this.listToFoot(function (node) {
		            re = re || iterator(node);
		        });
		        return re;
		    };
		    ListTree.prototype.every = function (iterator) {
		        var re = true;
		        this.listToFoot(function (node) {
		            re = re && iterator(node);
		        });
		        return re;
		    };
		    ListTree.prototype.concat = function (list) {
		        var newList = new ListTree();
		        this.listToFoot(function (node) { return newList.push(node); });
		        list.listToFoot(function (node) { return newList.push(node); });
		        return newList;
		    };
		    ListTree.prototype.clone = function () {
		        var newList = new ListTree();
		        this.listToFoot(function (v) { return newList.push(v); });
		        return newList;
		    };
		    ListTree.prototype.clear = function () {
		        this.length = 0;
		        this.head = null;
		        this.foot = null;
		        this.stickyHead = null;
		        this.stickyFoot = null;
		    };
		    return ListTree;
		}());
		{
		    Object.defineProperty(ListTree.prototype, "_debugToArray", {
		        get: function () {
		            return this.toArray();
		        },
		    });
		}

		exports.Comment = Comment;
		exports.Consumer = Consumer;
		exports.Context = Context;
		exports.Element = Element;
		exports.ForwardRef = ForwardRef;
		exports.Fragment = Fragment;
		exports.Lazy = Lazy;
		exports.ListTree = ListTree;
		exports.ListTreeNode = ListTreeNode;
		exports.Memo = Memo;
		exports.Offscreen = Offscreen;
		exports.Portal = Portal;
		exports.Profiler = Profiler;
		exports.Provider = Provider;
		exports.Root = Root;
		exports.Scope = Scope;
		exports.ScopeLazy = ScopeLazy;
		exports.ScopeSuspense = ScopeSuspense;
		exports.Strict = Strict;
		exports.Suspense = Suspense;
		exports.TYPEKEY = TYPEKEY;
		exports.UniqueArray = UniqueArray;
		exports.compareVersion = compareVersion;
		exports.exclude = exclude;
		exports.include = include;
		exports.isArray = isArray;
		exports.isArrayEquals = isArrayEquals;
		exports.isCollection = isCollection;
		exports.isFunction = isFunction;
		exports.isInteger = isInteger;
		exports.isNormalEquals = isNormalEquals;
		exports.isNumber = isNumber;
		exports.isObject = isObject;
		exports.isPromise = isPromise;
		exports.isString = isString;
		exports.isSymbol = isSymbol;
		exports.merge = merge;
		exports.once = once;
		exports.remove = remove; 
	} (index_development));
	return index_development;
}

var hasRequiredMyreactShared;

function requireMyreactShared () {
	if (hasRequiredMyreactShared) return myreactShared.exports;
	hasRequiredMyreactShared = 1;

	{
	  myreactShared.exports = requireIndex_development();
	}
	return myreactShared.exports;
}

var myreactSharedExports = requireMyreactShared();

var Scheduler = /** @class */ (function () {
    function Scheduler() {
        this.dispatchSet = new myreactSharedExports.UniqueArray();
    }
    Scheduler.prototype.microTask = function (_task) {
        microTask(_task);
    };
    Scheduler.prototype.macroTask = function (_task) {
        macroTask(_task);
    };
    Scheduler.prototype.yieldTask = function (_task) {
        return yieldTask(_task);
    };
    Scheduler.prototype.getFiberTree = function (_fiber) {
        throw new Error("Method not implemented.");
    };
    Scheduler.prototype.readContext = function (_params) {
        throw new Error("Method not implemented.");
    };
    Scheduler.prototype.readPromise = function (_params) {
        throw new Error("Method not implemented.");
    };
    Scheduler.prototype.dispatchHook = function (_params) {
        throw new Error("Method not implemented.");
    };
    Scheduler.prototype.dispatchState = function (_params) {
        throw new Error("Method not implemented.");
    };
    Scheduler.prototype.dispatchError = function (_params) {
        throw new Error("Method not implemented.");
    };
    Scheduler.prototype.dispatchPromise = function (_params) {
        throw new Error("Method not implemented.");
    };
    return Scheduler;
}());

/**
 * @public
 */
var createRef = function (value) {
    var refValue = { current: value };
    if (typeof Object.seal === "function")
        Object.seal(refValue);
    return refValue;
};
/**
 * @internal
 */
var createReadonlyRef = function (value) {
    var refValue = { current: value, readonly: true };
    if (typeof Object.freeze === "function")
        Object.freeze(refValue);
    return refValue;
};

// TODO gc
/**
 * @internal
 */
var fiberToDispatchMap = new Map();
/**
 * @internal
 */
var instanceToInitialFieldMap = new Map();
/**
 * @internal
 */
var dispatchToListenerMap = new Map();
/**
 * @internal
 */
var currentCallingFiber = [];
/**
 * @internal
 */
var currentError = createRef(null);
/**
 * @internal
 */
var currentScheduler = createRef(new Scheduler());
/**
 * @internal
 */
var globalLoop = createRef(false);
/**
 * @internal
 */
var currentRunningFiber = createRef(null);
/**
 * @internal
 */
var currentComponentFiber = createRef(null);
/**
 * @internal
 */
var currentScopeFiber = createRef(null);
/**
 * @internal
 */
var currentHookTreeNode = createRef(null);
/**
 * @internal
 */
var currentHookNodeIndex = createRef(0);
/**
 * @internal
 */
var enableLoopFromRoot = createReadonlyRef(true);
// ==== feature ==== //
/**
 * @internal
 */
var enableDebugLog = createRef(false);
/**
 * @internal
 */
var enableSyncFlush = createRef(false);
/**
 * @internal
 */
var enableHMRForDev = createReadonlyRef(true);
/**
 * @internal
 */
var enableConcurrentMode = createRef(true);
/**
 * @internal
 */
var enableOptimizeTreeLog = createRef(true);
/**
 * @internal
 */
var enableScopeTreeLog = createRef(true);
/**
 * @internal
 */
var enablePerformanceLog = createRef(true);
// TODO
// double render, 尝试实现优先级中断的渲染
/**
 * @internal
 */
var enableDoubleRender = createRef(false);
// support "unsafe_" lifecycle
/**
 * @internal
 */
var enableLegacyLifeCycle = createReadonlyRef(true);
// enable react-18 strict lifecycle method
// for now there are some bug for current flow, should not enable this feature flag
// TODO need improve strictMode flow
/**
 * @internal
 */
createRef(false);
/**
 * @internal
 */
var enableDebugFiled = createRef(true);
/**
 * @internal
 */
var enableMockReact = createReadonlyRef(true);

var yieldTask = typeof scheduler !== "undefined" && typeof scheduler.postTask === "function" && typeof AbortController === "function"
    ? function schedulerYieldTask(task) {
        var _a = new AbortController(), signal = _a.signal, abort = _a.abort;
        scheduler.postTask(task, { priority: "background", signal: signal });
        return function cancelYieldTask() {
            try {
                abort("");
            }
            catch (_a) {
            }
        };
    }
    : typeof requestIdleCallback === "function"
        ? function schedulerYieldTask(task) {
            var id = requestIdleCallback(task);
            return function cancelYieldTask() {
                cancelIdleCallback(id);
            };
        }
        : function schedulerYieldTask(task) {
            var id = setTimeout(task);
            return function cancelYieldTask() {
                clearTimeout(id);
            };
        };
var microTask = typeof queueMicrotask === "undefined"
    ? function schedulerMicroTask(task) {
        return Promise.resolve().then(task);
    }
    : queueMicrotask;
var set = new Set();
var pending = false;
function flashMacroTask() {
    if (pending)
        return;
    pending = true;
    setTimeout(function invokeMacroTask() {
        var allTask = new Set(set);
        set.clear();
        allTask.forEach(function (f) { return f(); });
        pending = false;
    });
}
var macroTask = function (task) {
    set.add(task);
    flashMacroTask();
};

var defaultDeps = [];
var defaultReducer = function (state, action) {
    return typeof action === "function" ? action(state) : action;
};
/**
 * @public
 */
var useStateHook = function (initial) {
    var renderScheduler = currentScheduler.current;
    if (!renderScheduler)
        throw new Error("[@my-react/react] current hook statement have been invoke in a invalid environment, you may: \n 1. using hook in a wrong way \n 2. current environment have multiple \"@my-react/react\" package \n 3. current environment not have a valid \"Platform\" package");
    return renderScheduler.dispatchHook({
        type: myreactSharedExports.HOOK_TYPE.useState,
        value: typeof initial === "function"
            ? initial
            : function initState() {
                return initial;
            },
        reducer: defaultReducer,
        deps: defaultDeps,
    });
};
/**
 * @public
 */
var useEffectHook = function (action, deps) {
    var renderScheduler = currentScheduler.current;
    if (!renderScheduler)
        throw new Error("[@my-react/react] current hook statement have been invoke in a invalid environment, you may: \n 1. using hook in a wrong way \n 2. current environment have multiple \"@my-react/react\" package \n 3. current environment not have a valid \"Platform\" package");
    return renderScheduler.dispatchHook({
        type: myreactSharedExports.HOOK_TYPE.useEffect,
        value: action,
        reducer: defaultReducer,
        deps: deps,
    });
};
/**
 * @public
 */
var useLayoutEffectHook = function (action, deps) {
    var renderScheduler = currentScheduler.current;
    if (!renderScheduler)
        throw new Error("[@my-react/react] current hook statement have been invoke in a invalid environment, you may: \n 1. using hook in a wrong way \n 2. current environment have multiple \"@my-react/react\" package \n 3. current environment not have a valid \"Platform\" package");
    return renderScheduler.dispatchHook({
        type: myreactSharedExports.HOOK_TYPE.useLayoutEffect,
        value: action,
        reducer: defaultReducer,
        deps: deps,
    });
};
/**
 * @public
 */
var useCallbackHook = function (callback, deps) {
    var renderScheduler = currentScheduler.current;
    if (!renderScheduler)
        throw new Error("[@my-react/react] current hook statement have been invoke in a invalid environment, you may: \n 1. using hook in a wrong way \n 2. current environment have multiple \"@my-react/react\" package \n 3. current environment not have a valid \"Platform\" package");
    return renderScheduler.dispatchHook({
        type: myreactSharedExports.HOOK_TYPE.useCallback,
        value: callback,
        reducer: defaultReducer,
        deps: deps,
    });
};
/**
 * @public
 */
var useMemoHook = function (action, deps) {
    var renderScheduler = currentScheduler.current;
    if (!renderScheduler)
        throw new Error("[@my-react/react] current hook statement have been invoke in a invalid environment, you may: \n 1. using hook in a wrong way \n 2. current environment have multiple \"@my-react/react\" package \n 3. current environment not have a valid \"Platform\" package");
    return renderScheduler.dispatchHook({
        type: myreactSharedExports.HOOK_TYPE.useMemo,
        value: action,
        reducer: defaultReducer,
        deps: deps,
    });
};
/**
 * @public
 */
var useRefHook = function (value) {
    var renderScheduler = currentScheduler.current;
    if (!renderScheduler)
        throw new Error("[@my-react/react] current hook statement have been invoke in a invalid environment, you may: \n 1. using hook in a wrong way \n 2. current environment have multiple \"@my-react/react\" package \n 3. current environment not have a valid \"Platform\" package");
    return renderScheduler.dispatchHook({
        type: myreactSharedExports.HOOK_TYPE.useRef,
        value: createRef(value),
        reducer: defaultReducer,
        deps: defaultDeps,
    });
};
/**
 * @public
 */
var useFunc = function (Context) {
    var renderScheduler = currentScheduler.current;
    if (!renderScheduler)
        throw new Error("[@my-react/react] current hook statement have been invoke in a invalid environment, you may: \n 1. using hook in a wrong way \n 2. current environment have multiple \"@my-react/react\" package \n 3. current environment not have a valid \"Platform\" package");
    if (myreactSharedExports.isPromise(Context)) {
        return renderScheduler.readPromise(Context);
    }
    else {
        return renderScheduler.readContext(Context);
    }
};
/**
 * @public
 */
var useContextHook = function (Context) {
    var renderScheduler = currentScheduler.current;
    if (!renderScheduler)
        throw new Error("[@my-react/react] current hook statement have been invoke in a invalid environment, you may: \n 1. using hook in a wrong way \n 2. current environment have multiple \"@my-react/react\" package \n 3. current environment not have a valid \"Platform\" package");
    return renderScheduler.dispatchHook({
        type: myreactSharedExports.HOOK_TYPE.useContext,
        value: Context,
        reducer: defaultReducer,
        deps: defaultDeps,
    });
};
/**
 * @public
 */
var useReducerHook = function (reducer, initialArgs, init) {
    var renderScheduler = currentScheduler.current;
    if (!renderScheduler)
        throw new Error("[@my-react/react] current hook statement have been invoke in a invalid environment, you may: \n 1. using hook in a wrong way \n 2. current environment have multiple \"@my-react/react\" package \n 3. current environment not have a valid \"Platform\" package");
    return renderScheduler.dispatchHook({
        type: myreactSharedExports.HOOK_TYPE.useReducer,
        value: typeof init === "function"
            ? function initReducer() {
                return init(initialArgs);
            }
            : function initReducer() {
                return initialArgs;
            },
        reducer: reducer,
        deps: defaultDeps,
    });
};
/**
 * @public
 */
var useImperativeHandleHook = function (ref, createHandle, deps) {
    var renderScheduler = currentScheduler.current;
    if (!renderScheduler)
        throw new Error("[@my-react/react] current hook statement have been invoke in a invalid environment, you may: \n 1. using hook in a wrong way \n 2. current environment have multiple \"@my-react/react\" package \n 3. current environment not have a valid \"Platform\" package");
    return renderScheduler.dispatchHook({
        type: myreactSharedExports.HOOK_TYPE.useImperativeHandle,
        value: ref,
        reducer: createHandle,
        deps: deps,
    });
};
/**
 * @public
 */
var useDebugValueHook = function () {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    var renderScheduler = currentScheduler.current;
    if (!renderScheduler)
        throw new Error("[@my-react/react] current hook statement have been invoke in a invalid environment, you may: \n 1. using hook in a wrong way \n 2. current environment have multiple \"@my-react/react\" package \n 3. current environment not have a valid \"Platform\" package");
    return renderScheduler.dispatchHook({
        type: myreactSharedExports.HOOK_TYPE.useDebugValue,
        value: args,
        reducer: defaultReducer,
        deps: defaultDeps,
    });
};
/**
 * @public
 */
var useSignalHook = function (initial) {
    var renderScheduler = currentScheduler.current;
    if (!renderScheduler)
        throw new Error("[@my-react/react] current hook statement have been invoke in a invalid environment, you may: \n 1. using hook in a wrong way \n 2. current environment have multiple \"@my-react/react\" package \n 3. current environment not have a valid \"Platform\" package");
    return renderScheduler.dispatchHook({
        type: myreactSharedExports.HOOK_TYPE.useSignal,
        value: typeof initial === "function"
            ? initial
            : function initSignal() {
                return initial;
            },
        reducer: defaultReducer,
        deps: defaultDeps,
    });
};
// TODO
/**
 * @public
 */
var useDeferredValueHook = function (value) {
    var renderScheduler = currentScheduler.current;
    if (!renderScheduler)
        throw new Error("[@my-react/react] current hook statement have been invoke in a invalid environment, you may: \n 1. using hook in a wrong way \n 2. current environment have multiple \"@my-react/react\" package \n 3. current environment not have a valid \"Platform\" package");
    return renderScheduler.dispatchHook({
        type: myreactSharedExports.HOOK_TYPE.useDeferredValue,
        value: value,
        reducer: defaultReducer,
        deps: defaultDeps,
    });
};
/**
 * @public
 */
var useIdHook = function () {
    var renderScheduler = currentScheduler.current;
    if (!renderScheduler)
        throw new Error("[@my-react/react] current hook statement have been invoke in a invalid environment, you may: \n 1. using hook in a wrong way \n 2. current environment have multiple \"@my-react/react\" package \n 3. current environment not have a valid \"Platform\" package");
    return renderScheduler.dispatchHook({
        type: myreactSharedExports.HOOK_TYPE.useId,
        value: 0,
        reducer: defaultReducer,
        deps: defaultDeps,
    });
};
/**
 * @public
 */
var useInsertionEffectHook = function (action, deps) {
    var renderScheduler = currentScheduler.current;
    if (!renderScheduler)
        throw new Error("[@my-react/react] current hook statement have been invoke in a invalid environment, you may: \n 1. using hook in a wrong way \n 2. current environment have multiple \"@my-react/react\" package \n 3. current environment not have a valid \"Platform\" package");
    return renderScheduler.dispatchHook({
        type: myreactSharedExports.HOOK_TYPE.useInsertionEffect,
        value: action,
        reducer: defaultReducer,
        deps: deps,
    });
};
/**
 * @public
 */
var useSyncExternalStoreHook = function (subscribe, getSnapshot, getServerSnapshot) {
    var renderScheduler = currentScheduler.current;
    if (!renderScheduler)
        throw new Error("[@my-react/react] current hook statement have been invoke in a invalid environment, you may: \n 1. using hook in a wrong way \n 2. current environment have multiple \"@my-react/react\" package \n 3. current environment not have a valid \"Platform\" package");
    return renderScheduler.dispatchHook({
        type: myreactSharedExports.HOOK_TYPE.useSyncExternalStore,
        value: { subscribe: subscribe, getSnapshot: getSnapshot, getServerSnapshot: getServerSnapshot },
        reducer: defaultReducer,
        deps: defaultDeps,
    });
};
/**
 * @public
 */
var useTransitionHook = function () {
    var renderScheduler = currentScheduler.current;
    if (!renderScheduler)
        throw new Error("[@my-react/react] current hook statement have been invoke in a invalid environment, you may: \n 1. using hook in a wrong way \n 2. current environment have multiple \"@my-react/react\" package \n 3. current environment not have a valid \"Platform\" package");
    return renderScheduler.dispatchHook({
        type: myreactSharedExports.HOOK_TYPE.useTransition,
        value: null,
        reducer: defaultReducer,
        deps: defaultDeps,
    });
};

// eslint-disable-next-line @typescript-eslint/no-unsafe-function-type
var cache = function (fn) {
    return fn();
};

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
/* global Reflect, Promise, SuppressedError, Symbol, Iterator */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    if (typeof b !== "function" && b !== null)
        throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

function __spreadArray(to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
}

typeof SuppressedError === "function" ? SuppressedError : function (error, suppressed, message) {
    var e = new Error(message);
    return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
};

var Dispatch = {
    readContext: useFunc,
    use: useFunc,
    useCallback: useCallbackHook,
    useContext: useContextHook,
    useDebugValue: useDebugValueHook,
    useDeferredValue: useDeferredValueHook,
    useEffect: useEffectHook,
    useId: useIdHook,
    useImperativeHandle: useImperativeHandleHook,
    useInsertionEffect: useInsertionEffectHook,
    useLayoutEffect: useLayoutEffectHook,
    useMemo: useMemoHook,
    useReducer: useReducerHook,
    useRef: useRefHook,
    useState: useStateHook,
    useSignal: useSignalHook,
    useSyncExternalStore: useSyncExternalStoreHook,
    useTransition: useTransitionHook,
};
var Dispatcher = createRef(__assign(__assign({}, Dispatch), { proxy: null }));
var resolveDispatcher = function () {
    var _a;
    if ((_a = Dispatcher.current) === null || _a === void 0 ? void 0 : _a.proxy) {
        return Dispatcher.current.proxy;
    }
    else {
        return Dispatcher.current;
    }
};

/**
 * @public
 */
var startTransition = function (cb) {
    if (currentScheduler.current) {
        currentScheduler.current.yieldTask(cb);
    }
    else {
        cb();
    }
};

/**
 * @public
 */
var isValidElement = function (element) {
    return typeof element === "object" && !Array.isArray(element) && element !== null && (element === null || element === void 0 ? void 0 : element[myreactSharedExports.TYPEKEY]) === myreactSharedExports.Element;
};
var keysMap = {};
var checkValidKey = function (children) {
    var obj = {};
    var renderScheduler = currentScheduler.current;
    var currentFiber = currentComponentFiber.current;
    var validElement = children.filter(function (c) { return isValidElement(c); });
    if (validElement.length) {
        validElement.forEach(function checkSingleElementValidKey(c) {
            var _a;
            if (!((_a = c._store) === null || _a === void 0 ? void 0 : _a["validKey"])) {
                if (typeof c.key === "string") {
                    if (obj[c.key]) {
                        var renderTree = currentFiber ? renderScheduler.getFiberTree(currentFiber) : "";
                        if (!keysMap[renderTree])
                            console.warn("[@my-react/react] array child have duplicate key ".concat(c.key));
                        keysMap[renderTree] = true;
                    }
                    obj[c.key] = true;
                }
                else {
                    var renderTree = currentFiber ? renderScheduler.getFiberTree(currentFiber) : "";
                    if (!keysMap[renderTree])
                        console.warn("[@my-react/react] each array child must have a unique key props");
                    keysMap[renderTree] = true;
                }
                if (c._store) {
                    c._store["validKey"] = true;
                }
            }
        });
    }
};
var optimizes = [];
var pushOptimizes = function (optimize) {
    optimizes.push(enableOptimizeTreeLog.current);
    enableOptimizeTreeLog.current = optimize;
};
var popOptimizes = function () {
    enableOptimizeTreeLog.current = optimizes.pop() || false;
};
// TODO
/**
 * @internal
 *
 */
var checkValidElement = function (element) {
    var _a, _b, _c, _d, _e;
    pushOptimizes(false);
    if (isValidElement(element)) {
        if (!((_a = element._store) === null || _a === void 0 ? void 0 : _a["validType"])) {
            var rawType = element.type;
            if (element.ref && typeof element.ref !== "object" && typeof element.ref !== "function") {
                console.error("[@my-react/react] invalid ref type, ref should be a function or a object like {current:  any}, but got a ".concat(element.ref));
            }
            if (element.key && typeof element.key !== "string") {
                console.error("[@my-react/react] invalid key type, key should be a string, but got a ".concat(element.key));
            }
            if (typeof rawType === "object" && rawType !== null) {
                var typedRawType = rawType;
                // check <Context.Consumer />
                if (typedRawType[myreactSharedExports.TYPEKEY] === myreactSharedExports.Consumer) {
                    var props = element.props;
                    for (var key in props) {
                        if (key !== "key" && key !== "children" && !key.startsWith("_")) {
                            console.warn("[@my-react/react] <Context.Consumer /> element only support 'key' / 'children' props, but got ".concat(key));
                        }
                    }
                    if (!(props === null || props === void 0 ? void 0 : props.children)) {
                        throw new Error("[@my-react/react] <Context.Consumer /> need a render function as children, this is unsupported usage");
                    }
                    if (typeof props.children !== "function") {
                        throw new Error("[@my-react/react] <Context.Consumer /> expect a render function as children but got ".concat(props.children, ", this is unsupported usage"));
                    }
                    if ((_c = (_b = props.children) === null || _b === void 0 ? void 0 : _b.prototype) === null || _c === void 0 ? void 0 : _c.isMyReactComponent) {
                        throw new Error("[@my-react/react] invalid render type for <Context.Consumer />, expect a render function but got a class element ".concat(props.children));
                    }
                }
                // check <Context />
                else if (typedRawType[myreactSharedExports.TYPEKEY] === myreactSharedExports.Context) {
                    // throw new Error(
                    //   `[@my-react/react] look like you are using Context like <Context />, this is unsupported usage, please use <Context.Provider /> or <Context.Consumer />`
                    // );
                    var props = element.props;
                    for (var key in props) {
                        if (key !== "key" && key !== "children" && key !== "value" && !key.startsWith("_")) {
                            console.warn("[@my-react/react] <Context /> element only support 'key' / 'value' / 'children' props, but got ".concat(key));
                        }
                    }
                }
                // check <Context.Provider />
                else if (typedRawType[myreactSharedExports.TYPEKEY] === myreactSharedExports.Provider) {
                    var props = element.props;
                    for (var key in props) {
                        if (key !== "key" && key !== "children" && key !== "value" && !key.startsWith("_")) {
                            console.warn("[@my-react/react] <Context.Provider /> element only support 'key' / 'value' / 'children' props, but got ".concat(key));
                        }
                    }
                }
                // check forwardRef()
                else if (typedRawType[myreactSharedExports.TYPEKEY] === myreactSharedExports.ForwardRef) {
                    var CurrentTypedRawType = rawType;
                    var targetRender = CurrentTypedRawType.render;
                    if (typeof targetRender !== "function") {
                        throw new Error("[@my-react/react] 'forwardRef()' expect a render function but got ".concat(targetRender, ", this is unsupported usage"));
                    }
                    if ((_d = targetRender.prototype) === null || _d === void 0 ? void 0 : _d.isMyReactComponent) {
                        throw new Error("[@my-react/react] invalid render type for 'forwardRef()', expect a render function, but got a element class ".concat(targetRender));
                    }
                }
                // check memo()
                else if (typedRawType[myreactSharedExports.TYPEKEY] === myreactSharedExports.Memo) {
                    var CurrentTypedRawType = rawType;
                    if (typeof CurrentTypedRawType.render === "object") {
                        if (isValidElement(CurrentTypedRawType.render)) {
                            throw new Error("[@my-react/react] look like you are using memo like memo(<Foo />), this is unsupported usage, please change to memo(Foo)");
                        }
                        if (CurrentTypedRawType.render[myreactSharedExports.TYPEKEY] === myreactSharedExports.Memo) {
                            throw new Error("[@my-react/react] look like you are using memo like memo(memo(Foo)), this is unsupported usage, please do not wrapper memo more than once");
                        }
                        if (CurrentTypedRawType.render[myreactSharedExports.TYPEKEY] === myreactSharedExports.Lazy) {
                            throw new Error("[@my-react/react] look like you are using memo like memo(lazy(loader fun)), this is unsupported usage");
                        }
                        if (CurrentTypedRawType.render[myreactSharedExports.TYPEKEY] === myreactSharedExports.Context) {
                            throw new Error("[@my-react/react] look like you are using memo like memo(Context), this is unsupported usage");
                        }
                    }
                    else if (typeof CurrentTypedRawType.render !== "function") {
                        throw new Error("[@my-react/react] invalid render type for 'memo()', expect a render function or a render object, but got a ".concat(CurrentTypedRawType.render));
                    }
                }
                // check lazy()
                else if (typedRawType[myreactSharedExports.TYPEKEY] === myreactSharedExports.Lazy) {
                    var CurrentTypedRawType = rawType;
                    var targetRender = CurrentTypedRawType.loader;
                    if (typeof targetRender !== "function") {
                        throw new Error("[@my-react/react] invalid argument for lazy(loader), the loader expect a function, but got a ".concat(CurrentTypedRawType.loader));
                    }
                    if ((_e = targetRender.prototype) === null || _e === void 0 ? void 0 : _e.isMyReactComponent) {
                        throw new Error("[@my-react/react] invalid argument for lazy(loader), the loader expect a function, but got a element class ".concat(CurrentTypedRawType.loader));
                    }
                }
                // check invalid object element
                else {
                    throw new Error("[@my-react/react] invalid object element type, current type is: ".concat(typedRawType));
                }
            }
            else {
                if (rawType === myreactSharedExports.Fragment) {
                    for (var key in element.props) {
                        if (key !== "key" && key !== "children" && key !== "wrap" && !key.startsWith("_")) {
                            console.warn("[@my-react/react] <Fragment /> element only support 'key' / 'children' props, but got ".concat(key));
                        }
                    }
                }
                if (rawType === myreactSharedExports.Suspense) {
                    for (var key in element.props) {
                        if (key !== "key" && key !== "children" && key !== "fallback" && !key.startsWith("_")) {
                            console.warn("[@my-react/react] <Suspense /> element only support 'key' / 'children' / 'fallback' props, but got ".concat(key));
                        }
                    }
                }
            }
        }
        if (element._store) {
            element._store["validType"] = true;
        }
    }
    popOptimizes();
};
/**
 * @internal
 */
var checkArrayChildrenKey = function (children) {
    pushOptimizes(false);
    children.forEach(function checkArrayChildKey(child) {
        if (Array.isArray(child)) {
            checkValidKey(child);
        }
        else {
            if (isValidElement(child) && child._store)
                child._store["validKey"] = true;
        }
    });
    popOptimizes();
};
/**
 * @internal
 */
var checkSingleChildrenKey = function (children) {
    pushOptimizes(false);
    if (Array.isArray(children)) {
        checkValidKey(children);
    }
    else {
        if (isValidElement(children) && children._store)
            children._store["validKey"] = true;
    }
    popOptimizes();
};

var _a;
var defaultObject = (_a = {}, _a[myreactSharedExports.TYPEKEY] = myreactSharedExports.Context, _a.displayName = "", _a);
/**
 * @public
 */
var createContext = function (value) {
    var _a, _b, _c;
    var ContextObject = (_a = {},
        _a[myreactSharedExports.TYPEKEY] = myreactSharedExports.Context,
        _a.Provider = {},
        _a.Consumer = {},
        _a);
    var ProviderObject = (_b = {},
        _b[myreactSharedExports.TYPEKEY] = myreactSharedExports.Provider,
        _b.value = value,
        _b.Context = defaultObject,
        _b);
    var ConsumerObject = (_c = {},
        _c[myreactSharedExports.TYPEKEY] = myreactSharedExports.Consumer,
        _c.Context = defaultObject,
        _c);
    Object.defineProperty(ProviderObject, "Context", {
        get: function () {
            return ContextObject;
        },
        enumerable: false,
        configurable: false,
    });
    Object.defineProperty(ConsumerObject, "Context", {
        get: function () {
            return ContextObject;
        },
        enumerable: false,
        configurable: false,
    });
    ContextObject.Provider = ProviderObject;
    ContextObject.Consumer = ConsumerObject;
    return ContextObject;
};
/**
 * @public
 */
var forwardRef = function (render) {
    var _a;
    var objectType = (_a = {},
        _a[myreactSharedExports.TYPEKEY] = myreactSharedExports.ForwardRef,
        _a.render = render,
        _a);
    return objectType;
};
/**
 * @public
 */
var memo = function (render, compare) {
    var _a;
    var objectType = (_a = {},
        _a[myreactSharedExports.TYPEKEY] = myreactSharedExports.Memo,
        _a.render = render,
        _a.compare = compare,
        _a);
    return objectType;
};
/**
 * @public
 */
var lazy = function (loader) {
    var _a;
    var config = (_a = {},
        _a[myreactSharedExports.TYPEKEY] = myreactSharedExports.Lazy,
        _a.loader = loader,
        _a._loading = false,
        _a._loaded = false,
        _a.render = null,
        _a);
    return config;
};

var createMyReactElement = function (_a) {
    var _b;
    var type = _a.type, key = _a.key, ref = _a.ref, props = _a.props, _self = _a._self, _source = _a._source, _owner = _a._owner;
    var element = (_b = {},
        _b[myreactSharedExports.TYPEKEY] = myreactSharedExports.Element,
        _b.type = type,
        _b.key = key,
        _b.ref = ref,
        _b.props = props,
        _b);
    {
        element._legacy = true;
        element._owner = _owner;
        element._self = _self;
        element._source = _source;
        element._store = {};
        if (typeof Object.freeze === "function") {
            Object.freeze(element.props);
            Object.freeze(element);
        }
    }
    return element;
};
/**
 * @public
 */
function createElement(type, config) {
    var children = [];
    for (var _i = 2; _i < arguments.length; _i++) {
        children[_i - 2] = arguments[_i];
    }
    var key = null;
    var ref = null;
    var self = null;
    var source = null;
    var props = {};
    if (config !== null && config !== undefined) {
        var _ref = config.ref, _key = config.key, __self = config.__self, __source = config.__source, resProps_1 = __rest(config, ["ref", "key", "__self", "__source"]);
        ref = _ref === undefined ? null : _ref;
        key = _key === undefined ? null : _key + "";
        self = __self === undefined ? null : __self;
        source = __source === undefined ? null : __source;
        Object.keys(resProps_1).forEach(function (key) { return (props[key] = resProps_1[key]); });
    }
    if (typeof type === "function" || typeof type === "object") {
        var typedType_1 = type;
        Object.keys((typedType_1 === null || typedType_1 === void 0 ? void 0 : typedType_1.defaultProps) || {}).forEach(function (key) { var _a; return (props[key] = props[key] === undefined ? (_a = typedType_1.defaultProps) === null || _a === void 0 ? void 0 : _a[key] : props[key]); });
    }
    var childrenLength = children.length;
    if (childrenLength > 1) {
        checkArrayChildrenKey(children);
        props.children = children;
    }
    else if (childrenLength === 1) {
        checkSingleChildrenKey(children[0]);
        props.children = children[0];
    }
    var element = createMyReactElement({
        type: type,
        key: key,
        ref: ref,
        props: props,
        _self: self,
        _source: source,
        _owner: currentComponentFiber.current,
    });
    checkValidElement(element);
    return element;
}
/**
 * @public
 */
function cloneElement(element, config, children) {
    if (element === null || element === undefined)
        throw new Error("[@my-react/react] cloneElement(...) need a valid element as params");
    if (typeof element !== "object")
        return element;
    element = element;
    var props = Object.assign({}, element.props);
    var key = element.key;
    var ref = element.ref;
    var type = element.type;
    var self = element._self;
    var source = element._source;
    var owner = element._owner;
    if (config !== null && config !== undefined) {
        var _ref = config.ref, _key = config.key; config.__self; config.__source; var resProps_2 = __rest(config, ["ref", "key", "__self", "__source"]);
        if (_ref !== undefined) {
            ref = _ref;
            owner = currentComponentFiber.current;
        }
        if (_key !== undefined)
            key = _key + "";
        var defaultProps_1 = {};
        if (typeof element.type === "function" || typeof element.type === "object") {
            var typedType = element.type;
            defaultProps_1 = (typedType === null || typedType === void 0 ? void 0 : typedType.defaultProps) || {};
        }
        Object.keys(resProps_2).forEach(function (key) { return (props[key] = resProps_2[key] === undefined ? defaultProps_1[key] : resProps_2[key]); });
    }
    var childrenLength = arguments.length - 2;
    if (childrenLength > 1) {
        children = Array.from(arguments).slice(2);
        checkArrayChildrenKey(children);
        props.children = children;
    }
    else if (childrenLength === 1) {
        checkSingleChildrenKey(children);
        props.children = children;
    }
    var clonedElement = createMyReactElement({
        type: type,
        key: key,
        ref: ref,
        props: props,
        _self: self,
        _source: source,
        _owner: owner,
    });
    if (clonedElement._store)
        clonedElement._store["clonedEle"] = true;
    checkValidElement(clonedElement);
    return clonedElement;
}
/**
 * @deprecated
 * @public
 */
function createFactory(type) {
    return function (config) {
        var children = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            children[_i - 1] = arguments[_i];
        }
        return createElement.apply(void 0, __spreadArray([type, config], children, false));
    };
}

var flatten = function (children) {
    if (Array.isArray(children))
        return children.reduce(function (p, c) { return p.concat(flatten(c)); }, []);
    return [children];
};
/**
 * @internal
 */
var mapByJudge = function (arrayLike, judge, action) {
    var arrayChildren = flatten(arrayLike);
    return arrayChildren.map(function (v, index) {
        if (judge(v)) {
            return action.call(null, v, index, arrayChildren);
        }
        else {
            return v;
        }
    });
};

// TODO there are still some error for `map`/`toArray` key props
var map = function (arrayLike, action, context) {
    if (arrayLike === null || arrayLike === undefined)
        return arrayLike;
    var res = [];
    mapByJudge(arrayLike, function () { return true; }, function (child, index) {
        var r = child;
        if (child === undefined || child === null || typeof child === "boolean") {
            r = null;
        }
        var element = action(r, index, context);
        if (isValidElement(element)) {
            res.push(cloneElement(element, { key: typeof element === "object" ? (typeof (element === null || element === void 0 ? void 0 : element.key) === "string" ? "".concat(element.key) : ".".concat(index)) : null }));
        }
        else {
            if (element !== undefined && element !== null) {
                res.push(element);
            }
        }
        return element;
    });
    return res;
};
var toArray = function (arrayLike) {
    var res = [];
    mapByJudge(arrayLike, function (v) { return v !== undefined && v !== null && typeof v !== "boolean"; }, function (child, index) {
        if (isValidElement(child)) {
            res.push(cloneElement(child, { key: typeof child === "object" ? (typeof (child === null || child === void 0 ? void 0 : child.key) === "string" ? "".concat(child.key) : ".".concat(index)) : null }));
        }
        else {
            res.push(child);
        }
        return child;
    });
    return res;
};
var forEach = function (arrayLike, action, context) {
    if (arrayLike === null || arrayLike === undefined)
        return;
    mapByJudge(arrayLike, function () { return true; }, function (child, index) {
        var r = child;
        if (child === undefined || (child === null && typeof child === "boolean")) {
            r = null;
        }
        return action(isValidElement(r) ? cloneElement(r) : r, index, context);
    });
};
var count = function (arrayLike) {
    if (Array.isArray(arrayLike))
        return arrayLike.reduce(function (p, c) { return p + count(c); }, 0);
    return 1;
};
var only = function (child) {
    if (isValidElement(child))
        return child;
    if (typeof child === "string" || typeof child === "number" || typeof child === "boolean")
        return true;
    throw new Error("[@my-react/react] Children.only() expected to receive a single MyReact element child.");
};

/**
 * @public
 */
var MyReactInternalInstance = /** @class */ (function () {
    function MyReactInternalInstance() {
    }
    Object.defineProperty(MyReactInternalInstance.prototype, "isMyReactInstance", {
        get: function () {
            return true;
        },
        enumerable: false,
        configurable: true
    });
    return MyReactInternalInstance;
}());

/**
 * @public
 */
var MyReactComponent = /** @class */ (function (_super) {
    __extends(MyReactComponent, _super);
    function MyReactComponent(props, context) {
        var _this = _super.call(this) || this;
        _this.state = null;
        _this.props = null;
        _this.context = null;
        _this.setState = function (payLoad, callback) {
            var updater = {
                type: myreactSharedExports.UpdateQueueType.component,
                payLoad: payLoad,
                callback: callback,
                trigger: _this,
                isForce: false,
                isSync: enableSyncFlush.current,
            };
            var renderScheduler = currentScheduler.current;
            renderScheduler === null || renderScheduler === void 0 ? void 0 : renderScheduler.dispatchState(updater);
        };
        _this.forceUpdate = function () {
            var updater = {
                type: myreactSharedExports.UpdateQueueType.component,
                trigger: _this,
                isForce: true,
                isSync: enableSyncFlush.current,
            };
            var renderScheduler = currentScheduler.current;
            renderScheduler === null || renderScheduler === void 0 ? void 0 : renderScheduler.dispatchState(updater);
        };
        _this.props = props || null;
        _this.context = context || null;
        return _this;
    }
    Object.defineProperty(MyReactComponent.prototype, "isReactComponent", {
        get: function () {
            return true;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MyReactComponent.prototype, "isMyReactComponent", {
        get: function () {
            return true;
        },
        enumerable: false,
        configurable: true
    });
    MyReactComponent.prototype.render = function () {
        return null;
    };
    return MyReactComponent;
}(MyReactInternalInstance));
/**
 * @internal
 */
var MyReactPureComponent = /** @class */ (function (_super) {
    __extends(MyReactPureComponent, _super);
    function MyReactPureComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    // for original react render, there are not a context judge for `shouldComponentUpdate` function
    MyReactPureComponent.prototype.shouldComponentUpdate = function (nextProps, nextState, nextContext) {
        return !myreactSharedExports.isNormalEquals(nextProps, this.props) || !myreactSharedExports.isNormalEquals(nextState, this.state) || !myreactSharedExports.isNormalEquals(nextContext, this.context);
    };
    return MyReactPureComponent;
}(MyReactComponent));

/**
 * @public
 */
var useState = function (initial) {
    var dispatcher = resolveDispatcher();
    return dispatcher.useState(initial);
};
/**
 * @public
 */
var useEffect = function (action, deps) {
    var dispatcher = resolveDispatcher();
    return dispatcher.useEffect(action, deps);
};
/**
 * @public
 */
var useLayoutEffect = function (action, deps) {
    var dispatcher = resolveDispatcher();
    return dispatcher.useLayoutEffect(action, deps);
};
/**
 * @public
 */
var useCallback = function (callback, deps) {
    var dispatcher = resolveDispatcher();
    return dispatcher.useCallback(callback, deps);
};
/**
 * @public
 */
var useMemo = function (action, deps) {
    var dispatcher = resolveDispatcher();
    return dispatcher.useMemo(action, deps);
};
/**
 * @public
 */
var useRef = function (value) {
    var dispatcher = resolveDispatcher();
    return dispatcher.useRef(value);
};
/**
 * @public
 */
var use = function (Context) {
    var dispatcher = resolveDispatcher();
    return dispatcher.use(Context);
};
/**
 * @public
 */
var useContext = function (Context) {
    var dispatcher = resolveDispatcher();
    return dispatcher.useContext(Context);
};
/**
 * @public
 */
var useReducer = function (reducer, initialArgs, init) {
    var dispatcher = resolveDispatcher();
    return dispatcher.useReducer(reducer, initialArgs, init);
};
/**
 * @public
 */
var useImperativeHandle = function (ref, createHandle, deps) {
    var dispatcher = resolveDispatcher();
    return dispatcher.useImperativeHandle(ref, createHandle, deps);
};
/**
 * @public
 */
var useDebugValue = function () {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    var dispatcher = resolveDispatcher();
    return dispatcher.useDebugValue.apply(dispatcher, args);
};
/**
 * @public
 */
var useSignal = function (initial) {
    var dispatcher = resolveDispatcher();
    return dispatcher.useSignal(initial);
};
// TODO
/**
 * @public
 */
var useDeferredValue = function (value) {
    var dispatcher = resolveDispatcher();
    return dispatcher.useDeferredValue(value);
};
/**
 * @public
 */
var useId = function () {
    var dispatcher = resolveDispatcher();
    return dispatcher.useId();
};
/**
 * @public
 */
var useInsertionEffect = function (action, deps) {
    var dispatcher = resolveDispatcher();
    return dispatcher.useInsertionEffect(action, deps);
};
/**
 * @public
 */
var useSyncExternalStore = function (subscribe, getSnapshot, getServerSnapshot) {
    var dispatcher = resolveDispatcher();
    return dispatcher.useSyncExternalStore(subscribe, getSnapshot, getServerSnapshot);
};
/**
 * @public
 */
var useTransition = function () {
    var dispatcher = resolveDispatcher();
    return dispatcher.useTransition();
};

/**
 * @public
 */
var Component = MyReactComponent;
/**
 * @public
 */
var PureComponent = MyReactPureComponent;
/**
 * @public
 */
var version = enableMockReact.current ? "18.2.0" : "0.3.10";
/**
 * @beta
 */
var __SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED = {
    ReactCurrentActQueue: {},
    ReactCurrentBatchConfig: {},
    ReactCurrentDispatcher: Dispatcher,
    ReactCurrentOwner: { current: null },
    ReactDebugCurrentFrame: {},
};
/**
 * @public
 */
var __my_react_shared__ = {
    enableMockReact: enableMockReact,
    enableDebugLog: enableDebugLog,
    enableSyncFlush: enableSyncFlush,
    enableHMRForDev: enableHMRForDev,
    enableDebugFiled: enableDebugFiled,
    enableScopeTreeLog: enableScopeTreeLog,
    enableLoopFromRoot: enableLoopFromRoot,
    enableDoubleRender: enableDoubleRender,
    enableConcurrentMode: enableConcurrentMode,
    enableLegacyLifeCycle: enableLegacyLifeCycle,
    enableOptimizeTreeLog: enableOptimizeTreeLog,
    enablePerformanceLog: enablePerformanceLog,
};
/**
 * @public
 */
var __my_react_scheduler__ = {
    yieldTask: yieldTask,
    macroTask: macroTask,
    microTask: microTask,
};
/**
 * @public
 */
var __my_react_internal__ = {
    MyReactInternalInstance: MyReactInternalInstance,
    globalLoop: globalLoop,
    createReadonlyRef: createReadonlyRef,
    Dispatcher: Dispatcher,
    fiberToDispatchMap: fiberToDispatchMap,
    dispatchToListenerMap: dispatchToListenerMap,
    instanceToInitialFieldMap: instanceToInitialFieldMap,
    currentScheduler: currentScheduler,
    currentScopeFiber: currentScopeFiber,
    currentRunningFiber: currentRunningFiber,
    currentCallingFiber: currentCallingFiber,
    currentHookTreeNode: currentHookTreeNode,
    currentHookNodeIndex: currentHookNodeIndex,
    currentComponentFiber: currentComponentFiber,
    currentError: currentError,
};
/**
 * @public
 */
var Children = {
    map: map,
    only: only,
    count: count,
    toArray: toArray,
    forEach: forEach,
};
var isMyReact = true;

exports.Children = Children;
exports.Component = Component;
exports.Fragment = myreactSharedExports.Fragment;
exports.Profiler = myreactSharedExports.Profiler;
exports.PureComponent = PureComponent;
exports.StrictMode = myreactSharedExports.Strict;
exports.Suspense = myreactSharedExports.Suspense;
exports.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED = __SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;
exports.__my_react_internal__ = __my_react_internal__;
exports.__my_react_scheduler__ = __my_react_scheduler__;
exports.__my_react_shared__ = __my_react_shared__;
exports.cache = cache;
exports.cloneElement = cloneElement;
exports.createContext = createContext;
exports.createElement = createElement;
exports.createFactory = createFactory;
exports.createRef = createRef;
exports.forwardRef = forwardRef;
exports.isMyReact = isMyReact;
exports.isValidElement = isValidElement;
exports.lazy = lazy;
exports.memo = memo;
exports.startTransition = startTransition;
exports.use = use;
exports.useCallback = useCallback;
exports.useContext = useContext;
exports.useDebugValue = useDebugValue;
exports.useDeferredValue = useDeferredValue;
exports.useEffect = useEffect;
exports.useId = useId;
exports.useImperativeHandle = useImperativeHandle;
exports.useInsertionEffect = useInsertionEffect;
exports.useLayoutEffect = useLayoutEffect;
exports.useMemo = useMemo;
exports.useReducer = useReducer;
exports.useRef = useRef;
exports.useSignal = useSignal;
exports.useState = useState;
exports.useSyncExternalStore = useSyncExternalStore;
exports.useTransition = useTransition;
exports.version = version;
